diff -Nur linux-2.4.30/arch/mips/au1000/common/time.c linux-2.4.30-linux-mips.org/arch/mips/au1000/common/time.c
--- linux-2.4.30/arch/mips/au1000/common/time.c	2005-01-19 15:09:26.000000000 +0100
+++ linux-2.4.30-linux-mips.org/arch/mips/au1000/common/time.c	2005-05-12 18:01:29.000000000 +0200
@@ -23,13 +23,16 @@
  *
  * ########################################################################
  *
- * Setting up the clock on the MIPS boards.
+ * Setting up the clock on the Alchemy boards.
  *
  * Update.  Always configure the kernel with CONFIG_NEW_TIME_C.  This
  * will use the user interface gettimeofday() functions from the
  * arch/mips/kernel/time.c, and we provide the clock interrupt processing
- * and the timer offset compute functions.  If CONFIG_PM is selected,
- * we also ensure the 32KHz timer is available.   -- Dan
+ * and the timer offset compute functions. -- Dan
+ */
+
+/*
+ * See discussion on kernel timer in Docuemtation/mips/Alchemy.README
  */
 
 #include <linux/types.h>
@@ -38,433 +41,524 @@
 #include <linux/kernel_stat.h>
 #include <linux/sched.h>
 #include <linux/spinlock.h>
+#include <linux/kernel.h>
+#include <linux/fcntl.h>
+#include <linux/miscdevice.h>
+#include <linux/module.h>
 
 #include <asm/compiler.h>
 #include <asm/mipsregs.h>
 #include <asm/ptrace.h>
 #include <asm/time.h>
 #include <asm/hardirq.h>
-#include <asm/div64.h>
+#include <asm/debug.h>
+#include <asm/time.h>
+#include <asm/uaccess.h>
 #include <asm/au1000.h>
-
-#include <linux/mc146818rtc.h>
 #include <linux/timex.h>
 
-extern void startup_match20_interrupt(void);
-extern void do_softirq(void);
-extern volatile unsigned long wall_jiffies;
-unsigned long missed_heart_beats = 0;
-
-static unsigned long r4k_offset; /* Amount to increment compare reg each time */
-static unsigned long r4k_cur;    /* What counter should be at next timer irq */
-extern rwlock_t xtime_lock;
-int	no_au1xxx_32khz;
-void	(*au1k_wait_ptr)(void);
-
-/* Cycle counter value at the previous timer interrupt.. */
-static unsigned int timerhi = 0, timerlo = 0;
-
-#ifdef CONFIG_PM
-#define MATCH20_INC 328
-extern void startup_match20_interrupt(void);
-static unsigned long last_pc0, last_match20;
+/* I haven't found anyone that doesn't use a 12 MHz source clock,
+ * but just in case.....
+ */
+#ifndef CONFIG_AU1000_SRC_CLK
+#define CONFIG_AU1000_SRC_CLK 12000000
+#endif
+
+/* I haven't found anyone that doesn't use a 32.768KHz crystal,
+ * but just in case.....
+ */
+#ifndef CONFIG_AU1000_32KHZ_CLK
+#define CONFIG_AU1000_32KHZ_CLK 32768
 #endif
 
 static spinlock_t time_lock = SPIN_LOCK_UNLOCKED;
 
-static inline void ack_r4ktimer(unsigned long newval)
-{
-	write_c0_compare(newval);
-}
+static u32 r4k_offset; /* Amount to increment compare reg each time */
+static u32 r4k_cur;    /* What counter should be at next timer irq */
 
-/*
- * There are a lot of conceptually broken versions of the MIPS timer interrupt
- * handler floating around.  This one is rather different, but the algorithm
- * is provably more robust.
- */
-unsigned long wtimer;
-void mips_timer_interrupt(struct pt_regs *regs)
-{
-	int irq = 63;
-	unsigned long count;
-	int cpu = smp_processor_id();
+extern int allow_au1k_wait; /* arch/mips/kernel/cpu-probe.c */
 
-	irq_enter(cpu, irq);
-	kstat.irqs[cpu][irq]++;
+#ifdef CONFIG_SOC_AU1X00_32KHZ_TIMER
+/* Use the integrated RTC timer as the system timer tick. RTC (counter1)
+match1 is used as the tick source */
 
-	if (r4k_offset == 0)
-		goto null;
+static volatile u32 rtcm1_offset; /* Amount to increment match reg each time */
+static volatile u32 rtcm1_cur;    /* What counter should be at next timer irq */
+static volatile u32 rtcm1_last;   /* What match/counter was at at the last timer irq */
+static volatile u32 rtcm1_drift;
 
-	do {
-		count = read_c0_count();
-		timerhi += (count < timerlo);   /* Wrap around */
-		timerlo = count;
-
-		kstat.irqs[0][irq]++;
-		do_timer(regs);
-		r4k_cur += r4k_offset;
-		ack_r4ktimer(r4k_cur);
+void rtcm1_irq(int irq, void *dev_id, struct pt_regs *regs)
+{
+	/* This handler mirrors mips_timer_interrupt() below, except that
+	this handler is called by do_IRQ() */
+	static int jiffie_drift = 0;
+	int num_do_timer = 0;
+	u32 rtc;
 
-	} while (((unsigned long)read_c0_count()
-	         - r4k_cur) < 0x7fffffff);
+	/* disable all other IRQs. without this, this handler can be
+	interrupted which allows the RTC to advance *WAY* ahead of the RTCM1
+	value which causes the kernel to hang, waiting for rollover. */
+	spin_lock_irq(&time_lock);
+
+	/* check if RTC counter has rolled-over, but rtcm1_cur has not */
+	rtc = au_readl(SYS_RTCREAD);
+	while (rtc < rtcm1_cur) {
+		++num_do_timer;
+		rtcm1_last = rtcm1_cur;
+		rtcm1_cur += rtcm1_offset;
+	}
+	while (rtcm1_cur < rtc) {
+		++num_do_timer;
+		rtcm1_last = rtcm1_cur;
+		rtcm1_cur += rtcm1_offset;
+		/* check if rtcm1_cur has rolled over, and thus ahead of rtc */
+		if (rtcm1_last > rtcm1_cur)
+			break;
+	}
+	jiffie_drift += num_do_timer;
+	if ((rtcm1_drift != 0) && (jiffie_drift >= rtcm1_drift)) {
+		jiffie_drift -= rtcm1_drift;
+		++num_do_timer;
+	}
+
+	/* Check to make sure that the counter is not at the value we're about
+	to program into the match; if so, adjust accordingly. */
+	rtc = au_readl(SYS_RTCREAD);
+
+	/* Check to make sure that the value programmed into RTCM1 is no more
+	than rtcm1_offset ticks away. This is complicated by the need to handle
+	32-bit rollover of the counter, and the fact that the RTC may be ahead
+	of RTCM1. This value represents the number of RTC ticks needed for this
+	code to read the current RTC value, make any decisions, and write
+	to RTCMATCH1. */
+#define RTCM1_UPDATE_DELAY 8
+	rtc += RTCM1_UPDATE_DELAY;
+
+	if (rtcm1_cur > rtc) {
+		if ((rtcm1_cur - rtc) < (2 * rtcm1_offset))
+			/* rtcm1_cur is just ahead of rtc */
+			au_writel(rtcm1_cur, SYS_RTCMATCH1); /* normal update */
+		else
+			/* rtc has rolled-over, ahead of rtcm1_cur */
+			au_writel(rtc + 2, SYS_RTCMATCH1); /* special update */
+	} else {
+		/* rtc > rtcm1_cur */
+		if ((rtc - rtcm1_cur) < (2 * rtcm1_offset))
+			/* rtc is just ahead of rtcm1_cur */
+			au_writel(rtc + 2, SYS_RTCMATCH1); /* special update */
+		else
+			/* rtcm1_cur has rolled-over, ahead of rtc */
+			au_writel(rtcm1_cur, SYS_RTCMATCH1); /* normal update */
+	}
 
-	irq_exit(cpu, irq);
+	while (num_do_timer-- > 0)
+		do_timer(regs);
 
-	if (softirq_pending(cpu))
-		do_softirq();
-	return;
+	/* SYS_CNTRCTRL_RM1 shouldn't need to be examined since this register is
+	written no faster than HZ rate, which is plenty long for the updates to
+	occur. Nonetheless, in practice this is needed, but by doing it at the
+	end, where the update likely should have already occured, we allow the
+	update to RTCM1 to occur in parallel with the calls to do_timer(). 
+	This also guarantees that the next rtcm1_irq() write to RTCMATCH1 can
+	occur without polling. */
+	while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RM1);
+
+	spin_unlock_irq(&time_lock);
+}
+
+static void setup_rtcm1_interrupt(void)
+{
+	/* Setup match1 to interrupt HZ times per second.
+	TODO: These calculations should be transformed into an
+	integer-only sequence, rather than computing manually... */
+	rtcm1_offset = CONFIG_AU1000_32KHZ_CLK / HZ;
+	if ((rtcm1_offset * HZ) != CONFIG_AU1000_32KHZ_CLK)
+		rtcm1_offset += 1; /* round up */
+	rtcm1_drift = 0;
+	if (HZ == 100) rtcm1_drift = 2500;
+	if (HZ == 1000) rtcm1_drift = 154;
+	rtcm1_cur = au_readl(SYS_RTCREAD) + rtcm1_offset;
+	while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RM1);
+	au_writel(rtcm1_cur, SYS_RTCMATCH1);
+	while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RM1);
+}
+
+static unsigned long do_fast_rtcm1_gettimeoffset(void)
+{
+	unsigned long rtc, offset;
+	static u32 num_huge_offsets = 0;
+
+	rtc = au_readl(SYS_RTCREAD);
+	if (rtc < rtcm1_last) /* RTC has rolled-over */
+		offset = (0 - rtcm1_last) + rtc;
+	else
+		offset = rtc - rtcm1_last;
+
+	/* NOTE: The huge offsets are unavoidable since Linux's interrupt
+	response time is highly irregular. */
+	if (offset > 2*rtcm1_offset) {
+		if (++num_huge_offsets > 100)
+		printk("huge offset %x, rtc %x, rtcm1_last %x rtcm1 %x rtcm1_cur %x\n",
+			offset, rtc, rtcm1_last, au_readl(SYS_RTCMATCH1), rtcm1_cur);
+	}
 
-null:
-	ack_r4ktimer(0);
+	/* What is the meaning of the magic numbers ??? */
+	offset = (unsigned long)((offset * 305) / 10);
+	return offset;
 }
+#endif /* CONFIG_SOC_AU1X00_32KHZ_TIMER */
 
-#ifdef CONFIG_PM
-void counter0_irq(int irq, void *dev_id, struct pt_regs *regs)
+#ifdef CONFIG_SOC_AU1X00_32KHZ
+static unsigned long rtc_au1xxx_get_time(void)
 {
-	unsigned long pc0;
-	int time_elapsed;
-	static int jiffie_drift = 0;
-
-	kstat.irqs[0][irq]++;
-	if (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_M20) {
-		/* should never happen! */
-		printk(KERN_WARNING "counter 0 w status eror\n");
-		return;
+	/* The TOY counter simply contains the number of seconds elapsed.
+	This is interpreted from the kernel viewpoint as the number of
+	seconds elapsed starting in 1970. */
+	return au_readl(SYS_TOYREAD);
 	}
 
-	pc0 = au_readl(SYS_TOYREAD);
-	if (pc0 < last_match20) {
-		/* counter overflowed */
-		time_elapsed = (0xffffffff - last_match20) + pc0;
+static int rtc_au1xxx_set_time(unsigned long t)
+{
+	/* Take the kernel's value and record it in the counter. There is
+	no need to spin on TS since this register is written infrequently. */
+	au_writel(t, SYS_TOYWRITE);
+	return 0;
 	}
-	else {
-		time_elapsed = pc0 - last_match20;
+
+static unsigned long rtc_au1xxx_get_toym2(void)
+{
+	return au_readl(SYS_TOYMATCH2);
 	}
 
-	while (time_elapsed > 0) {
-		do_timer(regs);
-		time_elapsed -= MATCH20_INC;
-		last_match20 += MATCH20_INC;
-		jiffie_drift++;
+static int rtc_au1xxx_set_toym2(unsigned long t)
+{
+	au_writel(t, SYS_TOYMATCH2);
+	return 0;
 	}
 
-	last_pc0 = pc0;
-	au_writel(last_match20 + MATCH20_INC, SYS_TOYMATCH2);
-	au_sync();
+/********************************************************************
+The following is the /dev/rtc driver that utilizes the TOY.
+This code a blatant pilfer of ds1742.c */
 
-	/* our counter ticks at 10.009765625 ms/tick, we we're running
-	 * almost 10uS too slow per tick.
-	 */
+#define AU1XXX_RTC_VERSION "1.0"
+#define RTC_IS_OPEN		0x1
+
+static unsigned long rtc_status = 0;
+static spinlock_t rtc_lock;
+
+extern void to_tm(unsigned long tim, struct rtc_time * tm);
+
+static int rtc_au1xxx_ioctl(struct inode *inode, struct file *file,
+				unsigned int cmd, unsigned long arg)
+{
+	struct rtc_time rtc_tm;
+	ulong curr_time;
+
+	switch (cmd) {
+	case RTC_RD_TIME:	/* Read the time/date from TOY */
+		curr_time = rtc_au1xxx_get_time();
+		memset(&rtc_tm, 0, sizeof(struct rtc_time));
+		to_tm(curr_time, &rtc_tm);
+		rtc_tm.tm_year -= 1900;
+		return copy_to_user((void *) arg, &rtc_tm, sizeof(rtc_tm)) ? 
+			-EFAULT : 0;
+		break;
+
+	case RTC_SET_TIME:
+		if (!capable(CAP_SYS_TIME))
+			return -EACCES;
+
+		if (copy_from_user(&rtc_tm, 
+				   (struct rtc_time *) arg,
+		                   sizeof(struct rtc_time))) 
+			return -EFAULT;
+
+		curr_time = mktime(rtc_tm.tm_year + 1900,
+				   rtc_tm.tm_mon + 1, /* tm_mon starts from 0 */
+				   rtc_tm.tm_mday,
+				   rtc_tm.tm_hour,
+				   rtc_tm.tm_min, 
+				   rtc_tm.tm_sec);
+		return rtc_au1xxx_set_time(curr_time);
+		break;
 
-	if (jiffie_drift >= 999) {
-		jiffie_drift -= 999;
-		do_timer(regs); /* increment jiffies by one */
+	case RTC_WKALM_RD:	/* Read the wakeup alarm time/date from TOY M2 */
+		curr_time = rtc_au1xxx_get_toym2();
+		memset(&rtc_tm, 0, sizeof(struct rtc_time));
+		to_tm(curr_time, &rtc_tm);
+		rtc_tm.tm_year -= 1900;
+		return copy_to_user((void *) arg, &rtc_tm, sizeof(rtc_tm)) ? 
+			-EFAULT : 0;
+		break;
+
+	case RTC_WKALM_SET:
+		if (!capable(CAP_SYS_TIME))
+			return -EACCES;
+
+		if (copy_from_user(&rtc_tm, 
+				   (struct rtc_time *) arg,
+		                   sizeof(struct rtc_time))) 
+			return -EFAULT;
+
+		curr_time = mktime(rtc_tm.tm_year + 1900,
+				   rtc_tm.tm_mon + 1, /* tm_mon starts from 0 */
+				   rtc_tm.tm_mday,
+				   rtc_tm.tm_hour,
+				   rtc_tm.tm_min, 
+				   rtc_tm.tm_sec);
+		return rtc_au1xxx_set_toym2(curr_time);
+		break;
+
+	default:
+		return -EINVAL;
 	}
 }
 
-/* When we wakeup from sleep, we have to "catch up" on all of the
- * timer ticks we have missed.
- */
-void
-wakeup_counter0_adjust(void)
+static int rtc_au1xxx_open(struct inode *inode, struct file *file)
 {
-	unsigned long pc0;
-	int time_elapsed;
+	int err = 0;
 
-	pc0 = au_readl(SYS_TOYREAD);
-	if (pc0 < last_match20) {
-		/* counter overflowed */
-		time_elapsed = (0xffffffff - last_match20) + pc0;
-	}
-	else {
-		time_elapsed = pc0 - last_match20;
-	}
+	spin_lock_irq(&rtc_lock);
 
-	while (time_elapsed > 0) {
-		time_elapsed -= MATCH20_INC;
-		last_match20 += MATCH20_INC;
-	}
+	if (rtc_status & RTC_IS_OPEN)
+		err = -EBUSY;
+	else {
+		/* If oscillator isn't running, then don't open() */
+		if (!(au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_32S))
+			err = -EIO;
+		else
+			rtc_status |= RTC_IS_OPEN;
+}
 
-	last_pc0 = pc0;
-	au_writel(last_match20 + MATCH20_INC, SYS_TOYMATCH2);
-	au_sync();
+	spin_unlock_irq(&rtc_lock);
 
+	return err;
 }
 
-/* This is just for debugging to set the timer for a sleep delay.
-*/
-void
-wakeup_counter0_set(int ticks)
+static int rtc_au1xxx_release(struct inode *inode, struct file *file)
 {
-	unsigned long pc0;
-
-	pc0 = au_readl(SYS_TOYREAD);
-	last_pc0 = pc0;
-	au_writel(last_match20 + (MATCH20_INC * ticks), SYS_TOYMATCH2);
-	au_sync();
+	spin_lock_irq(&rtc_lock);
+	rtc_status &= ~RTC_IS_OPEN;
+	spin_unlock_irq(&rtc_lock);
+	return 0;
 }
-#endif
 
-/* I haven't found anyone that doesn't use a 12 MHz source clock,
- * but just in case.....
- */
-#ifdef CONFIG_AU1000_SRC_CLK
-#define AU1000_SRC_CLK	CONFIG_AU1000_SRC_CLK
-#else
-#define AU1000_SRC_CLK	12000000
-#endif
+static struct file_operations rtc_au1xxx_fops = {
+	owner:THIS_MODULE,
+	llseek:no_llseek,
+	ioctl:rtc_au1xxx_ioctl,
+	open:rtc_au1xxx_open,
+	release:rtc_au1xxx_release,
+};
 
-/*
- * We read the real processor speed from the PLL.  This is important
- * because it is more accurate than computing it from the 32KHz
- * counter, if it exists.  If we don't have an accurate processor
- * speed, all of the peripherals that derive their clocks based on
- * this advertised speed will introduce error and sometimes not work
- * properly.  This function is futher convoluted to still allow configurations
- * to do that in case they have really, really old silicon with a
- * write-only PLL register, that we need the 32KHz when power management
- * "wait" is enabled, and we need to detect if the 32KHz isn't present
- * but requested......got it? :-)		-- Dan
- */
-unsigned long cal_r4koff(void)
+static struct miscdevice rtc_au1xxx_dev = {
+	RTC_MINOR,
+	"rtc",
+	&rtc_au1xxx_fops
+};
+
+static int __init rtc_au1xxx_init(void)
 {
-	unsigned long count;
-	unsigned long cpu_speed;
-	unsigned long flags;
-	unsigned long counter;
+	printk(KERN_INFO "Au1XXX Real Time Clock Driver v%s\n", AU1XXX_RTC_VERSION);
+	misc_register(&rtc_au1xxx_dev);
+	return 0;
+}
 
-	spin_lock_irqsave(&time_lock, flags);
+static void __exit rtc_au1xxx_exit(void)
+{
+	misc_deregister(&rtc_au1xxx_dev);
+}
 
-	/* Power management cares if we don't have a 32KHz counter.
-	*/
-	no_au1xxx_32khz = 0;
-	counter = au_readl(SYS_COUNTER_CNTRL);
-	if (counter & SYS_CNTRL_E0) {
-		int trim_divide = 16;
-
-		au_writel(counter | SYS_CNTRL_EN1, SYS_COUNTER_CNTRL);
-
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_T1S);
-		/* RTC now ticks at 32.768/16 kHz */
-		au_writel(trim_divide-1, SYS_RTCTRIM);
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_T1S);
-
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_C1S);
-		au_writel (0, SYS_TOYWRITE);
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_C1S);
+module_init(rtc_au1xxx_init);
+module_exit(rtc_au1xxx_exit);
+EXPORT_NO_SYMBOLS;
+/*******************************************************************/
 
-#if defined(CONFIG_AU1000_USE32K)
+static int au1xxx_32khz_startup(void)
 		{
-			unsigned long start, end;
+	/* Setup the 32kHz oscillator for operation per scheme described above */
 
-			start = au_readl(SYS_RTCREAD);
-			start += 2;
-			/* wait for the beginning of a new tick
-			*/
-			while (au_readl(SYS_RTCREAD) < start);
-
-			/* Start r4k counter.
-			*/
-			write_c0_count(0);
-
-			/* Wait 0.5 seconds.
-			*/
-			end = start + (32768 / trim_divide)/2;
+	if (!(au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_32S)) {
+		int timeout = 500000;
+		/* Start the 32khz oscillator - NOTE: usually best to do this
+		in the board boot up code to give the oscillator plenty of
+		time to startup prior to this code */
+		au_writel(SYS_CNTRCTRL_E0, SYS_COUNTER_CNTRL);
+		/* Wait for it to start...can hang here if there is
+		a problem with the 32khz oscillator!!! */
+		while (--timeout > 0)
+			if (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_32S)
+				break; /* oscillator started */
+	}
+
+	/* 32khz oscillator present and running */
+	if (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_32S) {
+		/* Configure RTC counter */
+		/* Set trim to 0 for max clock resolution */
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RTS);
+		au_writel(0, SYS_RTCTRIM);
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RTS);
+
+		/* start RTC counter at zero */
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RS);
+		au_writel(0, SYS_RTCWRITE);
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_RS);
+
+		/* Configure the TOY counter */
+		/* Set trim for 1 second clock resolution */
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_TTS);
+		au_writel(CONFIG_AU1000_32KHZ_CLK - 1, SYS_TOYTRIM);
+		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRCTRL_TTS);
 
-			while (end > au_readl(SYS_RTCREAD));
+		/* the TOY counter is not written since it contains date/time */
 
-			count = read_c0_count();
-			cpu_speed = count * 2;
+		return 1;
 		}
-#else
-		cpu_speed = (au_readl(SYS_CPUPLL) & 0x0000003f) * 
-			AU1000_SRC_CLK;
-		count = cpu_speed / 2;
-#endif
+	return 0;
 	}
-	else {
-		/* The 32KHz oscillator isn't running, so assume there
-		 * isn't one and grab the processor speed from the PLL.
-		 * NOTE: some old silicon doesn't allow reading the PLL.
-		 */
-		cpu_speed = (au_readl(SYS_CPUPLL) & 0x0000003f) * AU1000_SRC_CLK;
-		count = cpu_speed / 2;
-		no_au1xxx_32khz = 1;
-	}
-	mips_hpt_frequency = count;
-	// Equation: Baudrate = CPU / (SD * 2 * CLKDIV * 16)
-	set_au1x00_uart_baud_base(cpu_speed / (2 * ((int)(au_readl(SYS_POWERCTRL)&0x03) + 2) * 16));
-	spin_unlock_irqrestore(&time_lock, flags);
-	return (cpu_speed / HZ);
-}
-
-/* This is for machines which generate the exact clock. */
-#define USECS_PER_JIFFY (1000000/HZ)
-#define USECS_PER_JIFFY_FRAC (0x100000000*1000000/HZ&0xffffffff)
+#endif /* CONFIG_SOC_AU1X00_32KHZ */
 
-
-static unsigned long
-div64_32(unsigned long v1, unsigned long v2, unsigned long v3)
+static void setup_cp0_interrupt(void)
 {
-	unsigned long r0;
-	do_div64_32(r0, v1, v2, v3);
-	return r0;
+	/* Setup CP0 Count/Compare interrupt */
+	r4k_cur = (read_c0_count() + r4k_offset);
+	write_c0_compare(r4k_cur);
 }
 
-static unsigned long do_fast_cp0_gettimeoffset(void)
+void wakeup_kernel_timer(void)
 {
-	u32 count;
-	unsigned long res, tmp;
-	unsigned long r0;
+#ifdef CONFIG_SOC_AU1X00_32KHZ_TIMER
+	au1xxx_32khz_startup();
+	setup_rtcm1_interrupt();
+#else
+	setup_cp0_interrupt();
+#endif
+}
 
-	/* Last jiffy when do_fast_gettimeoffset() was called. */
-	static unsigned long last_jiffies=0;
-	unsigned long quotient;
+/* This is to set the timer upon resuming from sleep */
+void wakeup_toym2_set(int ticks)
+{
+#ifdef CONFIG_SOC_AU1X00_32KHZ
+	/* sets timeout from sleep mode */
+	u32 pc0 = au_readl(SYS_TOYREAD);
+	au_writel(pc0 + ticks, SYS_TOYMATCH2);
+#endif
+}
 
 	/*
-	 * Cached "1/(clocks per usec)*2^32" value.
-	 * It has to be recalculated once each jiffy.
+ * There are a lot of conceptually broken versions of the MIPS timer interrupt
+ * handler floating around.  This one is rather different, but the algorithm
+ * is provably more robust.
+ * This called directly by int-handler.S for Counter IRQ, as such, it must
+ * do more of what do_IRQ() does...
 	 */
-	static unsigned long cached_quotient=0;
-
-	tmp = jiffies;
-
-	quotient = cached_quotient;
+void mips_timer_interrupt(struct pt_regs *regs)
+{
+	extern void do_softirq(void);
+	int irq = 63; /* non-existant interrupt source??? */
+	int cpu = smp_processor_id();
 
-	if (tmp && last_jiffies != tmp) {
-		last_jiffies = tmp;
-		if (last_jiffies != 0) {
-			r0 = div64_32(timerhi, timerlo, tmp);
-			quotient = div64_32(USECS_PER_JIFFY, USECS_PER_JIFFY_FRAC, r0);
-			cached_quotient = quotient;
-		}
+	/* Count interrupt during init, or when 32khz timer enabled */
+	if (r4k_offset == 0) {
+		write_c0_compare(0); /* ack r4k timer */
+		return;
 	}
 
-	/* Get last timer tick in absolute kernel time */
-	count = read_c0_count();
-
-	/* .. relative to previous jiffy (32 bits is enough) */
-	count -= timerlo;
+	irq_enter(cpu, irq);
 
-	__asm__("multu\t%1,%2\n\t"
-		"mfhi\t%0"
-		: "=r" (res)
-		: "r" (count), "r" (quotient)
-		: "hi", "lo", GCC_REG_ACCUM);
+	do {
+		kstat.irqs[0][irq]++;
+		do_timer(regs);
+		r4k_cur += r4k_offset;
+		write_c0_compare(r4k_cur); /* ack r4k timer */
+	} while (((u32)read_c0_count() - r4k_cur) < 0x7fffffff);
 
-	/*
- 	 * Due to possible jiffies inconsistencies, we need to check 
-	 * the result so that we'll get a timer that is monotonic.
-	 */
-	if (res >= USECS_PER_JIFFY)
-		res = USECS_PER_JIFFY-1;
+	irq_exit(cpu, irq);
 
-	return res;
+	if (softirq_pending(cpu))
+		do_softirq();
 }
 
-#ifdef CONFIG_PM
-static unsigned long do_fast_pm_gettimeoffset(void)
+u32 cal_r4koff(void)
 {
-	unsigned long pc0;
-	unsigned long offset;
+	u32 cpu_freq, flags;
 
-	pc0 = au_readl(SYS_TOYREAD);
-	au_sync();
-	offset = pc0 - last_pc0;
-	if (offset > 2*MATCH20_INC) {
-		printk("huge offset %x, last_pc0 %x last_match20 %x pc0 %x\n", 
-				(unsigned)offset, (unsigned)last_pc0, 
-				(unsigned)last_match20, (unsigned)pc0);
-	}
-	offset = (unsigned long)((offset * 305) / 10);
-	return offset;
-}
-#endif
+	spin_lock_irqsave(&time_lock, flags);
 
-void __init au1xxx_timer_setup(void)
-{
-        unsigned int est_freq;
-	extern unsigned long (*do_gettimeoffset)(void);
-	extern void au1k_wait(void);
+#ifdef CONFIG_SOC_AU1000
+	/* On early Au1000s, sys_cpupll was write-only. Since these
+	silicon versions of Au1000 are not sold by AMD, we don't bend
+	over backwards trying to determine the frequency */
+#ifndef CONFIG_SOC_AU1000_FREQUENCY
+#define CONFIG_SOC_AU1000_FREQUENCY 396000000
+#endif
+	if ((read_c0_prid() == 0x00030100) || /* Au1000 DA */
+		(read_c0_prid() == 0x00030101) || /* Au1000 HA */
+		(read_c0_prid() == 0x00030102))   /* Au1000 HB */
+		cpu_freq = CONFIG_SOC_AU1000_FREQUENCY;
+	else
+#endif
+		cpu_freq = (au_readl(SYS_CPUPLL) & 0x0000003f) * CONFIG_AU1000_SRC_CLK;
 
-	printk("calculating r4koff... ");
-	r4k_offset = cal_r4koff();
-	printk("%08lx(%d)\n", r4k_offset, (int) r4k_offset);
+	mips_hpt_frequency = cpu_freq; /* On Alchemy, Count is 1:1 CPU */
+	/* Equation: Baudrate = CPU / (SD * 2 * CLKDIV * 16) */
+	set_au1x00_uart_baud_base(cpu_freq / (2 * ((int)(au_readl(SYS_POWERCTRL)&0x03) + 2) * 16));
+ 	set_au1x00_speed(cpu_freq);
+ 	set_au1x00_lcd_clock(); /* program the LCD clock */
 
-	//est_freq = 2*r4k_offset*HZ;	
-	est_freq = r4k_offset*HZ;	
-	est_freq += 5000;    /* round */
-	est_freq -= est_freq%10000;
-	printk("CPU frequency %d.%02d MHz\n", est_freq/1000000, 
-	       (est_freq%1000000)*100/1000000);
- 	set_au1x00_speed(est_freq);
- 	set_au1x00_lcd_clock(); // program the LCD clock
+	spin_unlock_irqrestore(&time_lock, flags);
 
-	r4k_cur = (read_c0_count() + r4k_offset);
-	write_c0_compare(r4k_cur);
+	return (cpu_freq / HZ);
+}
 
-	/* no RTC on the pb1000 */
-	xtime.tv_sec = 0;
-	xtime.tv_usec = 0;
+void __init au1xxx_timer_setup(void)
+{
+	/*	This code called at the end of time_init() in arch/mips/kernel/time.c.
+	The Cp0 Counter has already been chosen as the timer source, here we
+	can override the choices made by time_init(). */
+
+	/* Setup first CP0 timer interrupt */
+	setup_cp0_interrupt();
+
+#ifdef CONFIG_SOC_AU1X00_32KHZ_TIMER
+	/* Setup the 32kHz oscillator as the kernel timer instead */
+	if (au1xxx_32khz_startup()) {
+		extern void hook_rtcm1_interrupt(void);
+
+		/* it's too early to call request_irq(), but need to hook it anyway */
+		setup_rtcm1_interrupt();
+		hook_rtcm1_interrupt();
 
-#ifdef CONFIG_PM
-	/*
-	 * setup counter 0, since it keeps ticking after a
-	 * 'wait' instruction has been executed. The CP0 timer and
-	 * counter 1 do NOT continue running after 'wait'
-	 *
-	 * It's too early to call request_irq() here, so we handle
-	 * counter 0 interrupt as a special irq and it doesn't show
-	 * up under /proc/interrupts.
-	 *
-	 * Check to ensure we really have a 32KHz oscillator before
-	 * we do this.
-	 */
-	if (no_au1xxx_32khz) {
-		unsigned int c0_status;
+		/* use 32khz flavor of do_fast_gettimeoffset() */
+		do_gettimeoffset = do_fast_rtcm1_gettimeoffset;
 
-		printk("WARNING: no 32KHz clock found.\n");
-		do_gettimeoffset = do_fast_cp0_gettimeoffset;
+		/* short-circuit CP0 Count timer handler */
+		r4k_offset = 0;
 
-		/* Ensure we get CPO_COUNTER interrupts.
-		*/
-		c0_status = read_c0_status();
-		c0_status |= IE_IRQ5;
-		write_c0_status(c0_status);
+		/* allow WAIT instruction in cpu-probe.c */
+		allow_au1k_wait = 1;
 	}
 	else {
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_C0S);
-		au_writel(0, SYS_TOYWRITE);
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_C0S);
-
-		au_writel(au_readl(SYS_WAKEMSK) | (1<<8), SYS_WAKEMSK);
-		au_writel(~0, SYS_WAKESRC);
-		au_sync();
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_M20);
-
-		/* setup match20 to interrupt once every 10ms */
-		last_pc0 = last_match20 = au_readl(SYS_TOYREAD);
-		au_writel(last_match20 + MATCH20_INC, SYS_TOYMATCH2);
-		au_sync();
-		while (au_readl(SYS_COUNTER_CNTRL) & SYS_CNTRL_M20);
-		startup_match20_interrupt();
-
-		do_gettimeoffset = do_fast_pm_gettimeoffset;
-
-		/* We can use the real 'wait' instruction.
-		*/
-		au1k_wait_ptr = au1k_wait;
+		printk("WARNING: no 32KHz clock found...reverting to CP0 timer\n");
 	}
-
-#else
-	/* We have to do this here instead of in timer_init because
-	 * the generic code in arch/mips/kernel/time.c will write
-	 * over our function pointer.
-	 */
-	do_gettimeoffset = do_fast_cp0_gettimeoffset;
-#endif
+#endif /* CONFIG_SOC_AU1X00_32KHZ_TIMER */
 }
 
 void __init au1xxx_time_init(void)
 {
+	/* This called at the start of time_init() in arch/mips/kernel/time.c */
+	/* An RTC for use by time_init()/kernel is supposed to be setup here */
+
+#ifdef CONFIG_SOC_AU1X00_32KHZ
+	if (au1xxx_32khz_startup()) {
+		/* set the kernel function pointers */
+		rtc_get_time = rtc_au1xxx_get_time;
+		rtc_set_time = rtc_au1xxx_set_time;
+	}
+#endif /* CONFIG_SOC_AU1X00_32KHZ */
+
+	/* Determine CP0 timer values */
+	printk("calculating r4koff... ");
+	r4k_offset = cal_r4koff();
+	printk("%08lx(%d)\n", r4k_offset, (int) r4k_offset);
 }
diff -Nur linux-2.4.30/arch/mips/au1000/db1x00/board_setup.c linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/board_setup.c
--- linux-2.4.30/arch/mips/au1000/db1x00/board_setup.c	2005-01-19 15:09:26.000000000 +0100
+++ linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/board_setup.c	2005-05-12 17:57:05.000000000 +0200
@@ -46,10 +46,22 @@
 #include <asm/au1000.h>
 #include <asm/db1x00.h>
 
-extern struct rtc_ops no_rtc_ops;
+#if defined(CONFIG_BLK_DEV_IDE_AU1XXX) && defined(CONFIG_MIPS_DB1550)
+#include <asm/au1xxx_dbdma.h>
+extern struct ide_ops *ide_ops;
+extern struct ide_ops au1xxx_ide_ops;
+extern u32 au1xxx_ide_virtbase;
+extern u64 au1xxx_ide_physbase;
+extern int au1xxx_ide_irq;
+
+/* Ddma */
+chan_tab_t *ide_read_ch, *ide_write_ch;
+u32 au1xxx_ide_ddma_enable = 0, switch4ddma = 1; // PIO+ddma
+
+dbdev_tab_t new_dbdev_tab_element = { DSCR_CMD0_THROTTLE, DEV_FLAGS_ANYUSE, 0, 0, 0x00000000, 0, 0 };
+#endif /* end CONFIG_BLK_DEV_IDE_AU1XXX */
 
-/* not correct for db1550 */
-static BCSR * const bcsr = (BCSR *)0xAE000000;
+extern struct rtc_ops no_rtc_ops;
 
 void board_reset (void)
 {
@@ -57,6 +69,13 @@
 	au_writel(0x00000000, 0xAE00001C);
 }
 
+void board_power_off (void)
+{
+#ifdef CONFIG_MIPS_MIRAGE
+	au_writel((1 << 26) | (1 << 10), GPIO2_OUTPUT);
+#endif
+}
+
 void __init board_setup(void)
 {
 	u32 pin_func;
@@ -108,8 +127,42 @@
 	au_writel(0x02000200, GPIO2_OUTPUT);
 #endif
 
+#if defined(CONFIG_AU1XXX_SMC91111)
+#define CPLD_CONTROL (0xAF00000C)
+	{
+	extern uint32_t au1xxx_smc91111_base;
+	extern unsigned int au1xxx_smc91111_irq;
+	extern int au1xxx_smc91111_nowait;
+
+	au1xxx_smc91111_base = 0xAC000300;
+	au1xxx_smc91111_irq = AU1000_GPIO_8;
+	au1xxx_smc91111_nowait = 1;
+
+	/* set up the Static Bus timing - only 396Mhz */
+	bcsr->resets |= 0x7;
+	au_writel(0x00010003, MEM_STCFG0);
+	au_writel(0x000c00c0, MEM_STCFG2);
+	au_writel(0x85E1900D, MEM_STTIME2);
+	}
+#endif /* end CONFIG_SMC91111 */
 	au_sync();
 
+#if defined(CONFIG_BLK_DEV_IDE_AU1XXX) && defined(CONFIG_MIPS_DB1550)
+	/*
+	 * Iniz IDE parameters
+	 */
+	ide_ops = &au1xxx_ide_ops;
+	au1xxx_ide_irq = DAUGHTER_CARD_IRQ;
+	au1xxx_ide_physbase = AU1XXX_ATA_PHYS_ADDR;
+	au1xxx_ide_virtbase = KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR);
+
+	/*
+	 * change PIO or PIO+Ddma
+	 * check the GPIO-6 pin condition. db1550:s6_dot
+	 */
+	switch4ddma = (au_readl(SYS_PINSTATERD) & (1 << 6)) ? 1 : 0;
+#endif
+
 #ifdef CONFIG_MIPS_DB1000
     printk("AMD Alchemy Au1000/Db1000 Board\n");
 #endif
diff -Nur linux-2.4.30/arch/mips/au1000/db1x00/irqmap.c linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/irqmap.c
--- linux-2.4.30/arch/mips/au1000/db1x00/irqmap.c	2005-01-19 15:09:26.000000000 +0100
+++ linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/irqmap.c	2005-05-12 17:57:05.000000000 +0200
@@ -53,6 +53,7 @@
 #ifdef CONFIG_MIPS_DB1550
 	{ AU1000_GPIO_3, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 0 IRQ#
 	{ AU1000_GPIO_5, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 1 IRQ#
+	{ AU1000_GPIO_8, INTC_INT_LOW_LEVEL, 0 }, // Daughtercard IRQ#
 #else
 	{ AU1000_GPIO_0, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 0 Fully_Interted#
 	{ AU1000_GPIO_1, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 0 STSCHG#
diff -Nur linux-2.4.30/arch/mips/au1000/db1x00/Makefile linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/Makefile
--- linux-2.4.30/arch/mips/au1000/db1x00/Makefile	2005-01-19 15:09:26.000000000 +0100
+++ linux-2.4.30-linux-mips.org/arch/mips/au1000/db1x00/Makefile	2005-05-12 17:57:05.000000000 +0200
@@ -17,4 +17,11 @@
 obj-y := init.o board_setup.o irqmap.o
 obj-$(CONFIG_WM97XX_COMODULE) += mirage_ts.o
 
+ifdef CONFIG_MIPS_DB1100
+ifdef CONFIG_MMC
+obj-y += mmc_support.o
+export-objs += mmc_support.o
+endif
+endif
+
 include $(TOPDIR)/Rules.make
